{ Progress - Display progress of the current file and the total process

  Copyright (c) 1998 Gregory L. Bullock (bullock@tsppd.com).
  Freeware: May be freely distributed and modified. Use at your own risk.
}
unit Progress;

interface

uses Windows, Classes, SysUtils, Graphics, Forms, Controls, Buttons,
  StdCtrls, Gauges, ExtCtrls, FileCtrl;

type
  TProgressDlg = class(TForm)
    Bevel1: TBevel;
    ProgressBar: TGauge;
    Label1: TLabel;
    FileNameLabel: TLabel;
    Label2: TLabel;
    GeneralProgressBar: TGauge;
  private
    { Private declarations }
    FCurrentCompleted,
    FCurrentTotal,
    FCompleted,
    FTotal      : LongWord;
    procedure SetCompleted(Value: LongWord);
    procedure SetTotal(Value: LongWord);
    procedure SetCurrentCompleted(Value: LongWord);
    procedure SetCurrentTotal(Value: LongWord);
    procedure SetCurrentFileName(Value: TFileName);
  published
    property CurrentCompleted  : LongWord read FCurrentCompleted write SetCurrentCompleted;
    property CurrentTotal      : LongWord read FCurrentTotal write SetCurrentTotal;
    property Completed  : LongWord read FCompleted write SetCompleted;
    property Total      : LongWord read FTotal write SetTotal;
    property CurrentFileName  : TFileName write SetCurrentFileName;
  end;

procedure UpdateCurrentProgress(Completed: LongWord); far;

var
  ProgressDlg: TProgressDlg;

implementation

{$R *.DFM}

procedure UpdateCurrentProgress(Completed: LongWord);
begin
  ProgressDlg.CurrentCompleted := ProgressDlg.CurrentCompleted + Completed;
  ProgressDlg.Completed        := ProgressDlg.Completed + Completed;
end;

procedure TProgressDlg.SetCurrentCompleted(Value: LongWord);
begin
  FCurrentCompleted := Value;
  if FCurrentTotal > 0 then
    ProgressDlg.ProgressBar.Progress := MulDiv(FCurrentCompleted,100,FCurrentTotal);
  Application.ProcessMessages;
end;

procedure TProgressDlg.SetCurrentTotal(Value: LongWord);
begin
  FCurrentTotal := Value;
  FCurrentCompleted := 0;
  if FCurrentTotal > 0 then
    ProgressDlg.ProgressBar.Progress := MulDiv(FCurrentCompleted,100,FCurrentTotal);
  Application.ProcessMessages;
end;

procedure TProgressDlg.SetCompleted(Value: LongWord);
begin
  FCompleted := Value;
  if FTotal > 0 then
    GeneralProgressBar.Progress := MulDiv(FCompleted,100,FTotal);
  Application.ProcessMessages;
end;

procedure TProgressDlg.SetTotal(Value: LongWord);
begin
  FTotal := Value;
  FCompleted := 0;
  if FTotal > 0 then
    GeneralProgressBar.Progress := MulDiv(FCompleted,100,FTotal);
end;

procedure TProgressDlg.SetCurrentFileName(Value: TFileName);
begin
  FileNameLabel.Caption := MinimizeName(Value, Canvas, Bevel1.Width - FileNameLabel.Left);
end;

end.
